// -*- C++ -*-

// PtPipe.h
//
// Pipe wrapper for billg's pitch tracker
//
// for Audio Pattern Recognition Language (aprl)
// dpwe@media.mit.edu 1995feb25
//
/* $Header: /n/crab/da/dpwe/src/aprl/PtPipe.h,v 1.1 1996/11/18 18:42:29 dpwe Exp $ @media.mit.edu Machine Listening Group
 */

#ifndef _PTPIPE_H
#define _PTPIPE_H

#include "DataPipe.h"
#include "Ptrack.h"

class PtPipe : public DataPipe , public ptrack {
private:
    double opSampleRate;
    double fudge;
    int process(DATA *in, DATA *out, int* pinn, int *pmaxout, 
		double fudge, double ioratio);
public:
    PtPipe(double sr, DataSource *in=0)  : opSampleRate(sr), DataPipe(in) , 
        ptrack((long)in->SampleRate())
        { fudge = 0; 
	  if(opSampleRate > 0)  SetSampleRate(opSampleRate);
          else if(Input())	SetSampleRate(Input()->SampleRate()); };
    virtual ~PtPipe(void)
        { };
    void SetInput(DataSource *in) 
        { DataPipe::SetInput(in);
	  if(opSampleRate == 0 && Input())	
	      SetSampleRate(Input()->SampleRate()); };
    int Update(double time);
    void SetFilterParams(double hpffrq, double lpffrq, 
			 int hpfflag, int lpfflag, double decayT)
        {  Hpf_flag() = hpfflag;
	   Lpf_flag() = lpfflag;
	   Set_hpf_fc(hpffrq);
	   Set_lpf_fc(lpffrq);
	   Set_decay_tc(decayT);
       };
};

#endif /* _PTPIPE_H */
