//
// tclAudioSrc.cc
//
// tcl interface to AudioIO object
//
// for aprl - audio pattern recognition language
// dpwe@media.mit.edu 1995feb08
//
#ifndef lint
static char rcsid[] = "$Header: /u/drspeech/src/aprl/RCS/tclAudioSrc.cc,v 1.2 1999/01/09 02:30:20 dpwe Exp $ @media.mit.edu Machine Listening Group";
#endif /* lint */

#include <stdio.h>
#include <assert.h>
#include "AudioIO.h"

// ----------------------- TEMPLATE DECLARATION OF AUDIOSRC --------------

#define OBJECT		AudioSrc
#define TCLNAME		audiosrc
#define ISSOURCE
#define STRUCTFIELDS		\
    int         channels;	\
    double	sampleRate;	\
    double	bufferTime;	\
    double	scale;
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_DOUBLE, sampleRate, SampleRate, "8000.0")	\
    CONFIGLINE(TK_CONFIG_DOUBLE, scale, Scale, "1.0")			\
    CONFIGLINE(TK_CONFIG_INT, channels, Channels, "1")			\
    CONFIGLINE(TK_CONFIG_DOUBLE, bufferTime, BufferTime, "0.2")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)			\
    else if( (c=='f') && strncmp(argv[1], "filled", length)==0) {	\
	if(argc!=2)  {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[0], "filled \"", NULL);		\
	    result = TCL_ERROR;						\
	} else {							\
	    int filled = ptr->obj->Bufconts();				\
	    char s[32];							\
	    sprintf(s, "%d", filled);					\
	    Tcl_AppendResult(interp, s, NULL);				\
	}								\
    } else if( (c=='o') && strncmp(argv[1], "open", length)==0) {	\
	if(argc!=2)  {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[0], "open \"", NULL);		        \
	    result = TCL_ERROR;						\
	} else {							\
            ptr->obj->auOpen();                                         \
	}								\
    } else if( (c=='c') && strncmp(argv[1], "close", length)==0) {	\
	if(argc!=2)  {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[0], "close \"", NULL);		\
	    result = TCL_ERROR;						\
	} else {							\
            ptr->obj->auClose();                                        \
	}								\
    }
#define COMMANDLIST	"/filled/open/close"
#define CONSTRUCTCODE(PTR)	\
    PTR->obj = new AudioSrc(PTR->sampleRate, PTR->bufferTime, PTR->channels); \
    PTR->obj->setScale(PTR->scale);
#define CONFIGCODE(PTR)		\
    PTR->obj->setScale(PTR->scale);

#include "tclTemplate.h"

// ----------------------- TEMPLATE DECLARATION OF AUDIOSINK --------------

#define OBJECT		AudioSink
#define TCLNAME		audiosink
#define ISSINK
#define STRUCTFIELDS		\
    int         channels;	\
    double	sampleRate;	\
    double	scale;	
#define CONFIGLINES		\
    CONFIGLINE(TK_CONFIG_DOUBLE, sampleRate, SampleRate, "8000.0")	\
    CONFIGLINE(TK_CONFIG_DOUBLE, scale, Scale, "1.0")	\
    CONFIGLINE(TK_CONFIG_INT, channels, Channels, "1")
#define COMMANDCODE(interp,ptr,c,argc,argv,length)			\
    else if( (c=='f') && strncmp(argv[1], "filled", length)==0) {	\
	if(argc!=2)  {							\
	    Tcl_AppendResult(interp, "wrong # args: should be \"", 	\
			     argv[0], "filled \"", NULL);		\
	    result = TCL_ERROR;						\
	} else {							\
	    int filled = ptr->obj->Bufconts();				\
	    char s[32];							\
	    sprintf(s, "%d", filled);					\
	    Tcl_AppendResult(interp, s, NULL);				\
	}								\
    }
#define COMMANDLIST	"/filled"
#define CONSTRUCTCODE(PTR,IN)	\
    PTR->obj = new AudioSink(IN, PTR->channels, PTR->sampleRate);	\
    PTR->obj->setScale(PTR->scale);
#define CONFIGCODE(PTR)		\
    PTR->obj->setScale(PTR->scale);

#include "tclTemplate.h"
