#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include "db.h"
extern void 	PrintState(char **bufp);

#define FALSE 0
#define TRUE 1

char *mealstr[36] = {"","","","","","","","\"[B]\"","\"[B]\"","\"[B]\"","\"[L]\"","\"[L]\"","\"[L]\"","\"[L]\"","\"[L]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[L]\"","\"[L]\"","\"[L]\"","","\"[D]\"","\"[D]\"","\"[D]\"","\"[D]\"","\"[N]\"","\"[N]\"","\"[N]\"","\"[N]\""};

char *days[7] = {"sun","mon","tue","wed","thu","fri","sat"};
char *daynames[7] = {"SUNDAY","MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY"};

static void strcpyWithGap(char *newbuf, char*oldbuf,int gapstart, int gaplen);
static void strcpyWithRep(char *newbuf, char*oldbuf,int gapstart, int gaplen, char *rep);
static void CheckBlocks(char *buf);
static void CheckDontCare(char *buf,int);
static void CheckToday(char *buf);
static void CheckNow(char *buf);
static void CheckNot(char *buf);
static void CheckAnd(char *buf);
static void CheckDollars(char *buf);
static void CheckParens(char *buf);
static void CheckBetween(char *buf);
static void CheckRestName(char *buf);
static void CheckMealTime(char *buf);
static int CheckFlags(char *buf);
static void CheckTime(char *buf);
static char *GetToday();
static char *GetNow();
static char *GetTomorrow();
static void CheckAnyDay(char *buf);
static void CheckEveryDay(char *buf);
static void CheckNationality(char *buf);
static void CheckCost(char *buf);
static void CheckWhen(char *buf);
static void CheckMinutes(char *buf);
static int MGetNextToken(char *buffer, char*& p);
static int GetNextConjunct(char *buffer, char*& p);
static int GetNextConjunction(char *buffer, char*& p);
static int isspace(char c);
static int GetParen(char *& p);
static int GetOpenBrace(char *& p);
static char * meals(char *s);
char * strdays(char*s);
extern char *Template[];
extern char *PrintTemplate[];
extern char *RestaurantName;
static char *breakfast = "BREAKFAST";
static char *lunch =  "LUNCH";
static char *dinner = "DINNER";
static char *night = "LATE NIGHT";
static char *anymeal = "ANY MEAL";

static void error(char *s)
{
  extern int GrammarFileLineNumber;
  if (GrammarFileLineNumber>0)
    printf("Grammar file line %d:",GrammarFileLineNumber);
  printf(s);
  exit(1);
}


char tmpbuf[200];
int understood;

int XlateQuery(char * inpbuf,char *outbuf,int lastquestion)
{
	int flags = 0;
	int newflags = 0;
	char *p = inpbuf;
	char buf[400];
	char conj[50];

	understood = FALSE;
	

	GetOpenBrace(p);
	while (1) {
		(void) GetNextConjunction(conj,p);

		if (!GetNextConjunct(buf,p))
			break;

		(void) GetNextConjunction(conj,p);
		flags = CheckFlags(buf);
		CheckAnd(buf);
		CheckNot(buf);
		CheckBetween(buf);
		CheckNow(buf);
		CheckMealTime(buf);
		CheckToday(buf);
		CheckDontCare(buf,lastquestion);
		CheckAnyDay(buf);
		CheckEveryDay(buf);
		CheckBlocks(buf);
		CheckTime(buf);
		CheckDollars(buf);
		CheckNationality(buf);
		CheckCost(buf);
		CheckMinutes(buf);
		CheckWhen(buf);
		CheckRestName(buf);

//		if (!GetNextConjunction(buf,p))
//			break;
		if (newflags = CheckFlags(buf)) {
			flags |= newflags;
//			if (!GetNextConjunction(buf,p))
//				break;
		}
		CheckParens(buf);
		if (buf[0]) {
			strcat(outbuf,buf);
			strcat(outbuf," ");
			strcat(outbuf,conj);
			strcat(outbuf," ");
		}
	}

//	printf("Flags are 0x%x\n",flags);
	if (!understood && (!flags))
		flags |= FLAG_CONFUSED;
	return flags;
}

char *FindString(char * text, char * pat)
{
	char *p = text;
	int x = strlen(pat);

	if (strlen(text) < strlen(pat))
	  return NULL;
	
	while (*p) {
		if (!strncmp(pat,p,x))
		  return p;
		p++;
	}
	return NULL;
}

void strcpyWithGap(char *newbuf, char*oldbuf,int gapstart, int gaplen)
{
	strncpy(newbuf,oldbuf,gapstart);
	strcpy(newbuf+gapstart,oldbuf+gapstart+gaplen);
}

void strcpyWithRep(char *newbuf, char*oldbuf,int gapstart, int gaplen, char *rep)
{
	strncpy(newbuf,oldbuf,gapstart);
	strcpy(newbuf+gapstart,rep);
	strcpy(newbuf+gapstart+strlen(rep),oldbuf+gapstart+gaplen);
}

void CheckMealTime(char *buf)
{
	char *p = buf;
        char s1[30];

	MGetNextToken(s1,p);
        if (!strcmp(s1,"\"[B]\"") || !strcmp(s1,"\"[BLD]\"")  || !strcmp(s1,"\"[N]\"") || !strcmp(s1,"\"[L]\"") || !strcmp(s1,"\"[D]\"")) {
		understood = TRUE;
		sprintf(Template[WHENMEALQ],"%s",s1);
		sprintf(PrintTemplate[WHENMEALQ],"%s",meals(s1));
	}
}

char * meals(char *s)
{
	if (!strcmp(s,"\"[B]\"")) return breakfast;
	if (!strcmp(s,"\"[L]\"")) return lunch;
	if (!strcmp(s,"\"[D]\"")) return dinner;
	if (!strcmp(s,"\"[N]\"")) return night;
	if (!strcmp(s,"\"[BLD]\"")) return anymeal;
}

void  CheckRestName(char *buf)
{
	char *p = buf;
	char s1[30];

#ifdef DEBUG
	printf("GetR: buf is '%s'\n",buf);
#endif
	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.restname")) {
		MGetNextToken(s1,p);
#ifdef DEBUG
		printf("GetR: token is %s\n",s1);
#endif
		strcat(RestaurantName,s1);
		understood = TRUE;
	}
}
int GetRestNum(char *buf)
{
	char *p = buf;
	char s1[30];

	//printf("GetR: buf is '%s'\n",buf);
	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.restnum")) {
		MGetNextToken(s1,p);
		//printf("GetR: token is %s,atoi is %d\n",s1,atoi(s1));
		understood = TRUE;
		return atoi(s1);
	}
	return 0;
}
		

void CheckAnd(char *buf)
{
	char *p = buf;
        char s1[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"and")) 
		sprintf(buf,"(%s",p);
}


void CheckNot(char *buf)
{
	char *p = buf;
        char s1[30];
	char * tmp;
	char tempbuf[BUFSIZ];
	char * eqloc, *orloc, *tildeloc;

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"NOT")) {
		tmp = p;
		GetParen(p);
		MGetNextToken(s1,p);
		if (!strcmp(s1,"REST.minutes")) {
			MGetNextToken(s1,p);
			if (s1[0] == '>') {
				MGetNextToken(s1,p);
				sprintf(buf,"(REST.minutes <= %s)",s1);
			}
		}
		if (!strcmp(s1,"REST.dollars")) {
			MGetNextToken(s1,p);
			if (s1[0] == '>') {
				MGetNextToken(s1,p);
				sprintf(buf,"(REST.dollars <= %s)",s1);
			}
		}
		if (!strcmp(s1,"REST.rest_type")) {
			eqloc = FindString(tmp," = ");
			strcpyWithRep(buf, tmp, eqloc-tmp, 3, " != ");
			orloc = FindString(buf," or ");
			strcpyWithRep(tempbuf, buf, orloc-buf, 4, " and ");
			tildeloc = FindString(tempbuf," ~ ");
			strcpyWithRep(buf, tempbuf, tildeloc-tempbuf, 3, " !~ ");
			strrchr(buf,')')[0] = 0;
		}
	}
}


void CheckBetween(char *buf)
{
	char *p = buf;
        char s1[30], s2[30], s3[30];

	GetParen(p);
	MGetNextToken(s1,p);
	MGetNextToken(s2,p);
	if (!strcmp(s2,"BETWEEN"))  {
		MGetNextToken(s2,p);
		MGetNextToken(s3,p);
		sprintf(buf,"(%s <= %s)",s1,s3);
		understood = TRUE;
	}
}
 

void CheckAnyDay(char *buf)
{
	char *p = buf;
	char s1[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (strcmp(s1,"REST.ANY"))
		return;
	else {
	        //sprintf(buf,"(REST.mon ~ %s  or REST.tue ~ %s  or REST.wed ~ %s  or REST.thu ~ %s  or REST.fri ~ %s  or REST.sat ~ %s  or REST.sun ~ %s )",s2,s2,s2,s2,s2,s2,s2);
	        //sprintf(Template[WHENDAYQ],"(REST.mon or REST.tue or REST.wed or REST.thu or REST.fri or REST.sat or REST.sun)");
		sprintf(Template[WHENDAYQ],"ANY DAY");
	        //strcpy(Template[WHENMEALQ],s2);
		sprintf(PrintTemplate[WHENDAYQ],"ANY DAY");
		//strcpy(PrintTemplate[WHENMEALQ],meals(s2));
		understood = TRUE;
	}
}

void CheckWhen(char *buf)
{
	char *p = buf;
	char s1[30];

	GetParen(p);
	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.mon") ||
		!strcmp(s1,"WEEKENDS") ||
		!strcmp(s1,"REST.tue") || !strcmp(s1,"REST.wed") ||
		!strcmp(s1,"REST.thu") || !strcmp(s1,"REST.fri") ||
		!strcmp(s1,"REST.sat") || !strcmp(s1,"REST.sun")) {
		strcpy(Template[WHENDAYQ],s1);
		if (!strcmp(s1,"WEEKENDS"))
			sprintf(PrintTemplate[WHENDAYQ],"ON THE WEEKEND");
		else
			sprintf(PrintTemplate[WHENDAYQ],"%s",strdays(s1+5));
		understood = TRUE;
	}
}

char * strdays(char*s)
{
	int i;
	for (i=0;i<7;i++)
		if (!strcmp(s,days[i])) return daynames[i];
}

void CheckEveryDay(char *buf)
{
	char *p = buf;
	char s1[30], s2[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (strcmp(s1,"REST.EVERY"))
		return;
	else {
	        //sprintf(buf,"(REST.mon ~ %s  and REST.tue ~ %s  and REST.wed ~ %s  and REST.thu ~ %s  and REST.fri ~ %s  and REST.sat ~ %s  and REST.sun ~ %s )",s2,s2,s2,s2,s2,s2,s2);
	        //sprintf(Template[WHENDAYQ],"(REST.mon and REST.tue and REST.wed and REST.thu and REST.fri and REST.sat and REST.sun)");
	        sprintf(Template[WHENDAYQ],"EVERY DAY");
	        //strcpy(Template[WHENMEALQ],s2);
		sprintf(PrintTemplate[WHENDAYQ],"OPEN EVERY DAY");
		//strcpy(PrintTemplate[WHENMEALQ],meals(s2));
		understood = TRUE;
	}
}


void CheckTime(char *buf)
{
	char *p = buf;
	char s1[30];
	int index;
	int i;
	

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.time")) {
		MGetNextToken(s1,p);
		i = atoi(s1);
		MGetNextToken(s1,p);		
		if (s1 && s1[0] == 'a')
		  index = 0;
		else if (s1 && s1[0] == 'p')
		  index = 1;
		else index = 2;
		sprintf(buf," %s ",mealstr[index*12 + i]);
		understood = TRUE;
	}
}

char * costs[4] = {"(REST.cost = \"$\")","(REST.cost = \"$$\")","(REST.cost = \"$$$\")","(REST.cost = \"$$$$\")"};

void CheckDontCare(char *buf, int Last)
{
	int j;
	char *p = buf;
	char s1[30];

	MGetNextToken(s1,p);
	if (!strcmp(s1,"DONTCARE")) {
		if (Last == HOWMUCH) {
  		  sprintf(buf,"(%s",costs[0]);
		  for (j=1; j<4; j++) {
			  strcat(buf," or ");
	  		  strcat(buf,costs[j]);
		  }
		  strcat(buf,")");
		  strcpy(Template[HOWMUCHQ],buf);
		  sprintf(PrintTemplate[HOWMUCHQ],"DOESN'T MATTER");
		} else if (Last == WHERE) {
			sprintf(buf,"(REST.minutes < 10000)");
			strcpy(Template[WHEREQ],buf);
			sprintf(PrintTemplate[WHEREQ],"DOESN'T MATTER");
		} else if (Last == WHAT) {
			buf[0] = 0;
			Template[WHATQ][0] = 0;
			sprintf(PrintTemplate[WHATQ],"DOESN'T MATTER");
		} else if (Last == WHENDAY) {
			buf[0] = 0;
			//sprintf(buf,"(REST.ANY ~ \"[BLD]\")");
			Template[WHENDAYQ][0] = 0;
			sprintf(PrintTemplate[WHENDAYQ],"DOESN'T MATTER");
		} else if (Last == WHENMEAL) {
			buf[0] = 0;
			Template[WHENMEALQ][0] = 0;
			sprintf(PrintTemplate[WHENMEALQ],"DOESN'T MATTER");
		} 
		understood = TRUE;
	}
}


void CheckParens(char *buf)
{
	char *p = buf;

	if (!GetParen(p)) 
		buf[0] = 0;
}
	

void CheckDollars(char *buf)
{
	char *p = buf;
	int i;
	char s1[30];
	int LessFlag = 0;
	int j;

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.dollarstot")) {
		MGetNextToken(s1,p);
		if (s1 && (s1[0] == '<'))
		  LessFlag = TRUE;
		MGetNextToken(s1,p);
		i = atoi(s1) / 12;
		if (i > 3) i = 3;
		if (i == 0) LessFlag = TRUE;
		if (!LessFlag)
		  sprintf(buf,"%s",costs[i]);
		else {
  		  sprintf(buf,"(%s",costs[0]);
		  for (j=1; j<i+1; j++) {
			  strcat(buf," or ");
	  		  strcat(buf,costs[j]);
		  }
		  strcat(buf,")");
	        }
		understood = TRUE;
	} else if (!strcmp(s1,"REST.dollars")) {
		MGetNextToken(s1,p);
		if (s1 && (s1[0] == '<'))
		  LessFlag = TRUE;
		MGetNextToken(s1,p);
		i = atoi(s1) / 6;
		if (i > 3) i = 3;
		if (i == 0) LessFlag = TRUE;
		if (!LessFlag)
		  sprintf(buf,"%s",costs[i]);
		else {
  		  sprintf(buf,"(%s",costs[0]);
		  for (j=1; j<i+1; j++) {
			  strcat(buf," or ");
	  		  strcat(buf,costs[j]);
		  }
		  strcat(buf,")");
	        }
		understood = TRUE;
	}
}
		

void CheckBlocks(char *buf)
{
	char *p = buf;
	int i;
	int factor;
	char s1[30], s2[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (strcmp(s1,"REST.blocks")) {
		if (strcmp(s1,"REST.kilometers")) {
			if (strcmp(s1,"REST.miles")) {
				return;
			} else	
				factor = 20;
		} else
			factor = 12;
	} else
		factor = 5;
	
	understood = TRUE;
	MGetNextToken(s1,p);
	MGetNextToken(s2,p);
	i = atoi(s2);
	i *= factor;
	sprintf(buf,"(REST.minutes <= %d)",i);
}
		
void CheckMinutes(char *buf)
{
	char *p = buf;
	char s1[30];
	char s2[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.minutes")) {
		MGetNextToken(s1,p);
		MGetNextToken(s2,p);
		strcpy(Template[WHEREQ],buf);
		if (!strcmp(s2,"10000"))
			sprintf(PrintTemplate[WHEREQ],"ANYWHERE",s2);
		else if (!strcmp(s1,"<") || !strcmp(s1,"<="))
			sprintf(PrintTemplate[WHEREQ],"Less than %s minutes from ICSI",s2);
		else
			sprintf(PrintTemplate[WHEREQ],"More than %s minutes from ICSI",s2);
		understood = TRUE;
	}
}

void CheckNationality(char *buf)
{
	char *p = buf;
	char s1[30];
	char s2[30];

	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.rest_type")) {
		MGetNextToken(s2,p);
		MGetNextToken(s1,p);
		s1[strlen(s1)-1] = 0;
		if (!strcmp(s1,"\"FAS"))
			strcpy(s1," FAST FOOD");
		strcpy(Template[WHATQ],buf);
		if (!strcmp(s2,"!="))
			sprintf(PrintTemplate[WHATQ],"NOT %s",s1+1);
		else
			sprintf(PrintTemplate[WHATQ],s1+1);
		understood = TRUE;
	}
}
void CheckCost(char *buf)
{
	int costflags[4];
	static char * coststrings[4] = {"$","$$","$$$","$$$$"};
	int left, right,i;

	for (i=0;i<4;i++)
		costflags[i] = 0;

	if (!FindString(buf,"REST.cost"))
		return;
	if (FindString(buf,"REST.cost = \"$\""))
		costflags[0] = 1;
	if (FindString(buf,"REST.cost = \"$$\""))
		costflags[1] = 1;
	if (FindString(buf,"REST.cost = \"$$$\""))
		costflags[2] = 1;
	if (FindString(buf,"REST.cost = \"$$$$\""))
		costflags[3] = 1;

	for (i=0;i<4;i++) {
		if (costflags[i]) {
			left = i;
			break;
		}
	}
	for (i=3;i>=0;i--) {
		if (costflags[i]) {
			right = i;
			break;
		}
	}
	if (right == left)
		sprintf(PrintTemplate[HOWMUCHQ],coststrings[left]);
	else 
		sprintf(PrintTemplate[HOWMUCHQ],"%s-%s",coststrings[left],coststrings[right]);
	strcpy(Template[HOWMUCHQ],buf);
	understood = TRUE;
}	

void CheckNow(char *buf)
{
	char *p = buf;
	char s1[30];
	
	GetParen(p);
	MGetNextToken(s1,p);
	if (!strcmp(s1,"REST.NOW")) {
		sprintf(buf,"(REST.TOD)",GetNow());
		sprintf(Template[WHENMEALQ],"%s",GetNow());
		sprintf(PrintTemplate[WHENMEALQ],"%s",meals(GetNow()));
		understood = TRUE;
	}
}


void CheckToday(char *buf)
{
	char *s;
	
	if (s = FindString(buf,"TOD")) {
		strcpyWithRep(tmpbuf,buf,s-buf,3,GetToday());
		strcpy(buf,tmpbuf);
	} else if (s = FindString(buf,"TOM")) {
		strcpyWithRep(tmpbuf,buf,s-buf,3,GetTomorrow());
		strcpy(buf,tmpbuf);
	}
	understood = TRUE;
}
	

int CheckFlags(char *buf)
{
	char * s;
	int flags = 0;
	int i;

	for(i=0;i<2;i++) {
//		if (s = FindString(buf,"GETADDRESS")) {
//			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("GETADDRESS"));
//			strcpy(buf,tmpbuf);
//			flags |= FLAG_ADDRESS;
//		}

		if (s = FindString(buf,"GETFOODTYPES")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("GETFOODTYPES"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_GETTYPES;
		}

//		if (s = FindString(buf,"SETFOREIGN")) {
//			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("SETFOREIGN"));
//			strcpy(buf,tmpbuf);
//			flags |= FLAG_FOREIGN;
//		}

		if (s = FindString(buf,"GETRESERVE")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("GETRESERVE"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_RESERVATIONS;
		}

		if (s = FindString(buf,"GETMENU")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("GETMENU"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_MENU;
		}

		if (s = FindString(buf,"RESTART")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("RESTART"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_RESTART;
		}
		if (s = FindString(buf,"RECOMMEND")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("RECOMMEND"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_RECOMMEND;
		}

		if (s = FindString(buf,"WAITER")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("WAITER"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_WAITER;
		}
		//if (s = FindString(buf,"DONE")) {
////			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("DONE"));
////			strcpy(buf,tmpbuf);
//			flags |= FLAG_QUIT;
//		}
		if (s = FindString(buf,"HELP")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("HELO"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_HELP;
		}
		if (s = FindString(buf,"SHOWLIST")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("SHOWLIST"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_SHOWLIST;
		}
		if (s = FindString(buf,"THANKS")) {
			strcpyWithGap(tmpbuf,buf,(int)(s-buf),strlen("THANKS"));
			strcpy(buf,tmpbuf);
			flags |= FLAG_THANKS;
		}
	}
	return flags;
}
		

char *GetTomorrow()
{
	time_t  clock = time(0);
	struct tm *t = localtime(&clock);

	return days[t->tm_wday+1];
}

char *GetNow()
{
	time_t  clock = time(0);
        struct tm *t = localtime(&clock);

	return mealstr[t->tm_hour];
}
	

char *GetToday()
{
	time_t  clock = time(0);
	char *s;

	s = ctime(&clock);
	s[0] = s[0] - 'A' + 'a';
	s[4] = 0;
	return s;
}

static int MGetNextToken(char *buffer, char*& p)
{
        char *x = buffer;

        /* ignore leading whitespace */
        while (isspace(*p))
                p++;
        if (*p == '\0')
                return FALSE;

        /* copy token until whitespace or NULL or endparen */

	while ( !isspace(*p) && (*p != '\0') && (*p != ')'))
	  *buffer++ = *p++;

        *buffer = '\0';

        return TRUE;
}
int GetNextConjunct(char *buffer, char*& p)
{
        char *x = buffer;
	int count = 0;

        /* ignore leading whitespace */
        while (isspace(*p))
                p++;
        if ((*p == '\0') || (*p == '}'))
                return FALSE;

        /* copy token until whitespace or NULL */

	if (*p == '(') {
		*buffer++ = *p++;
		while ( ((*p != ')')||(count!=0)) && (*p != '\0') && (*p != '}')) {
			if (*p == '(') count++;
			if (*p == ')') count--;
	                *buffer++ = *p++;
		}
	        if (*p == ')')
	               *buffer++ = *p++;
	        else 
		       error("No close paren");
        } else {
		while ( !isspace(*p) && (*p != '\0') && (*p != '}')) 
		  *buffer++ = *p++;
	}

        *buffer = '\0';

        return TRUE;
}
int GetNextConjunction(char *buffer, char*& p)
{
        char *x = buffer;
	char *herebuf,*here;

        /* ignore leading whitespace */
        while (isspace(*p) && (*p != '\0'))
                p++;
        if ((*p == '\0') || (*p == '}'))
                return FALSE;

        /* copy token until whitespace or NULL */

	here = p;
	herebuf = buffer;

	while ( !isspace(*p) && (*p != '\0') && (*p != '}') )
	  *buffer++ = *p++;

	if (strncmp(here,"and",3) && strncmp(here,"or",2)) {
		p = here;
		buffer = herebuf;
        	*buffer = '\0';
		return FALSE;
	}

        *buffer = '\0';

        return TRUE;
}
static int isspace(char c)
{
        return ((c == ' ') || (c == '\t') );
}




static int GetParen(char *& p)
{
       /* ignore leading whitespace */
        while (isspace(*p))
                p++;
        if (*p == '\0')
                return FALSE;

        if (*p++ == '(') 
		return TRUE;
	else {
		p--;
		return FALSE;
	}
}
static int GetOpenBrace(char *& p)
{
       /* ignore leading whitespace */
//        while (isspace(*p))          // altered to allow extra 
        while (*p && *p != '{')        //   stuff before query (Dan G)
                p++;
        if (*p == '\0')
                return FALSE;

        if (*p++ == '{')
                return TRUE;
        else
                return FALSE;
}

