#ifndef __UNIFY_HASH
#define __UNIFY_HASH

#include <strings.h>	// for strlen() etc prototypes

char *StringTableEntry(char *str);
/* returns a permanent pointer to the string s 
 *  in the string table.  Adds an entry to the table if necessary.
 */
#ifndef NULL
#define NULL 0
#endif /* NULL */

class HashTable {
	private:	// fwd ref needed for DEC-OSF/1's cxx
	class Link;

	public:
	char *entry(char *str);	// returns pointer to same string -
				// adds to table if not already present
	HashTable(int s = 223)
		: buckets(new Link *[s]), sizeOfTable(s), count(0)
				{	for(int i = 0; i < sizeOfTable; i++)
						buckets[i] = NULL; }
	~HashTable() {	for (int i = 0; i < sizeOfTable; i++)
				delete buckets[i];
			delete [] buckets; }
	private:
	class Link {
		public:
		Link(char *str, Link *n = NULL) { 
				s = new char[strlen(str) + 1];
				strcpy(s, str);
				next = n; }
		~Link() { delete [] s; delete next; }
		char *s;
		Link *next;
	};
	int sizeOfTable, count;	/* num of buckets, num of strings in table */
	Link **buckets;
	void rehash();	       /* double num of buckets */
	int hash(char *s);     /* return hash value mod sizeOfTable */
};

#endif /* __UNIFY_HASH */
