/*
    Version: $Header: /u/spert/src/fltvec/php/RCS/convol_vfvf_vf.c,v 1.7 1995/10/13 01:12:37 davidj Exp $
    vector-vector convolution, y = h * x
    Generated by /u/bedk/speech/src/convol/gen_php_convol
*/

#include <fltv-config.h>
#include <stddef.h>
#include <assert.h>
#include <stdio.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

#ifdef DECL_php_convol_vfvf_vf
void php_convol_vfvf_vf(size_t h_len, size_t x_len, const float *h,
			const float *x, float *y);
#endif
#ifdef DECL_php_convol_vdvd_vd
void php_convol_vdvd_vd(size_t h_len, size_t x_len, const double *h,
			const double *x, double *y);
#endif


#ifdef DEFN_php_convol_vfvf_vf
#define FP_TYPE float
#define CONVOL php_convol_vfvf_vf
#endif

#ifdef DEFN_php_convol_vdvd_vd
#define FP_TYPE double
#define CONVOL php_convol_vdvd_vd
#endif

void
CONVOL(size_t h_len, size_t x_len, const FP_TYPE *h,
       const FP_TYPE *x, FP_TYPE *y) {
  const size_t h_ntail = h_len & (4 - 1);
  const size_t x_ntail = x_len & (4 - 1);
  const FP_TYPE *const h_tailp = h + h_len - h_ntail;
  const FP_TYPE *hp;

  const FP_TYPE *x_startp = x;
  const FP_TYPE *xp;

  const FP_TYPE *const y_triendp = y + h_len - h_ntail;
  const FP_TYPE *const y_tailp = y + x_len - x_ntail;
  const FP_TYPE *const y_endp  = y + x_len;

  register FP_TYPE h0;
  register FP_TYPE h1;
  register FP_TYPE h2;
  register FP_TYPE h3;
  register FP_TYPE x0;
  register FP_TYPE x1;
  register FP_TYPE x2;
  register FP_TYPE x3;
  register FP_TYPE y0;
  register FP_TYPE y1;
  register FP_TYPE y2;
  register FP_TYPE y3;

  /* die if the filter is longer than the signal */
  assert(x_len >= h_len);

  while (y != y_triendp) {
    hp = h;
    xp = x_startp;

    h0 = *(hp + 0);
    h1 = *(hp + 1);
    h2 = *(hp + 2);
    h3 = *(hp + 3);
    x0 = *(xp + 0);
    x1 = *(xp + 1);
    x2 = *(xp + 2);
    x3 = *(xp + 3);
    y0 = 0.0f;
    y1 = 0.0f;
    y2 = 0.0f;
    y3 = 0.0f;

    /* do the blocks */
    while (xp != x) {
      xp -= 4;

      y3 += h0 * x3;
      y2 += h0 * x2;
      y1 += h0 * x1;
      y0 += h0 * x0;
      x3 = *(xp + 3);

      y3 += h1 * x2;
      y2 += h1 * x1;
      y1 += h1 * x0;
      y0 += h1 * x3;
      x2 = *(xp + 2);

      y3 += h2 * x1;
      y2 += h2 * x0;
      y1 += h2 * x3;
      y0 += h2 * x2;
      x1 = *(xp + 1);

      y3 += h3 * x0;
      y2 += h3 * x3;
      y1 += h3 * x2;
      y0 += h3 * x1;
      x0 = *(xp + 0);

      h0 = *(hp + 4);
      h1 = *(hp + 5);
      h2 = *(hp + 6);
      h3 = *(hp + 7);
      hp += 4;
    }

    y3 += h0 * x3;
    y2 += h0 * x2;
    y1 += h0 * x1;
    y0 += h0 * x0;
    y3 += h1 * x2;
    y2 += h1 * x1;
    y1 += h1 * x0;
    y3 += h2 * x1;
    y2 += h2 * x0;
    y3 += h3 * x0;

    *(y + 0) = y0;
    *(y + 1) = y1;
    *(y + 2) = y2;
    *(y + 3) = y3;
    y += 4;
    x_startp += 4;
  }

  if (h_ntail != 0 && y != y_tailp) {
    hp = h;
    xp = x_startp;

    h0 = *(hp + 0);
    h1 = *(hp + 1);
    h2 = *(hp + 2);
    h3 = *(hp + 3);
    x0 = *(xp + 0);
    x1 = *(xp + 1);
    x2 = *(xp + 2);
    x3 = *(xp + 3);
    y0 = 0.0f;
    y1 = 0.0f;
    y2 = 0.0f;
    y3 = 0.0f;

    /* do the blocks */
    while (hp != h_tailp) {
      xp -= 4;

      y3 += h0 * x3;
      y2 += h0 * x2;
      y1 += h0 * x1;
      y0 += h0 * x0;
      x3 = *(xp + 3);

      y3 += h1 * x2;
      y2 += h1 * x1;
      y1 += h1 * x0;
      y0 += h1 * x3;
      x2 = *(xp + 2);

      y3 += h2 * x1;
      y2 += h2 * x0;
      y1 += h2 * x3;
      y0 += h2 * x2;
      x1 = *(xp + 1);

      y3 += h3 * x0;
      y2 += h3 * x3;
      y1 += h3 * x2;
      y0 += h3 * x1;
      x0 = *(xp + 0);

      h0 = *(hp + 4);
      h1 = *(hp + 5);
      h2 = *(hp + 6);
      h3 = *(hp + 7);
      hp += 4;
    }

    switch (h_ntail) {
    case 3:
      y3 += h2 * x1;
      y2 += h2 * x0;
      /* NO break */
    case 2:
      y3 += h1 * x2;
      y2 += h1 * x1;
      y1 += h1 * x0;
      /* NO break */
    case 1:
      y3 += h0 * x3;
      y2 += h0 * x2;
      y1 += h0 * x1;
      y0 += h0 * x0;
      break;
    default:
      assert(0);
      break;
    }

    *(y + 0) = y0;
    *(y + 1) = y1;
    *(y + 2) = y2;
    *(y + 3) = y3;
    y += 4;
    x_startp += 4;
  }

  while (y != y_tailp) {
    hp = h;
    xp = x_startp;

    h0 = *(hp + 0);
    h1 = *(hp + 1);
    h2 = *(hp + 2);
    h3 = *(hp + 3);
    x0 = *(xp + 0);
    x1 = *(xp + 1);
    x2 = *(xp + 2);
    x3 = *(xp + 3);
    y0 = 0.0f;
    y1 = 0.0f;
    y2 = 0.0f;
    y3 = 0.0f;

    /* do the blocks */
    while (hp != h_tailp) {
      xp -= 4;

      y3 += h0 * x3;
      y2 += h0 * x2;
      y1 += h0 * x1;
      y0 += h0 * x0;
      x3 = *(xp + 3);

      y3 += h1 * x2;
      y2 += h1 * x1;
      y1 += h1 * x0;
      y0 += h1 * x3;
      x2 = *(xp + 2);

      y3 += h2 * x1;
      y2 += h2 * x0;
      y1 += h2 * x3;
      y0 += h2 * x2;
      x1 = *(xp + 1);

      y3 += h3 * x0;
      y2 += h3 * x3;
      y1 += h3 * x2;
      y0 += h3 * x1;
      x0 = *(xp + 0);

      h0 = *(hp + 4);
      h1 = *(hp + 5);
      h2 = *(hp + 6);
      h3 = *(hp + 7);
      hp += 4;
    }

    if (h_ntail == 0) goto done;
    xp -= 4;
    y3 += h0 * x3;
    y2 += h0 * x2;
    y1 += h0 * x1;
    y0 += h0 * x0;

    if (h_ntail == 1) goto done;
    x3 = *(xp + 3);
    y3 += h1 * x2;
    y2 += h1 * x1;
    y1 += h1 * x0;
    y0 += h1 * x3;

    if (h_ntail == 2) goto done;
    x2 = *(xp + 2);
    y3 += h2 * x1;
    y2 += h2 * x0;
    y1 += h2 * x3;
    y0 += h2 * x2;

  done:
    *(y + 0) = y0;
    *(y + 1) = y1;
    *(y + 2) = y2;
    *(y + 3) = y3;
    y += 4;
    x_startp += 4;
  }

  while (y != y_endp) {
    hp = h;
    xp = x_startp++;

    h0 = *(hp + 0);
    h1 = *(hp + 1);
    h2 = *(hp + 2);
    h3 = *(hp + 3);
    y0 = 0.0f;

    while (hp != h_tailp) {
      xp -= 4;
      x0 = *(xp+4);
      x1 = *(xp + 1);
      x2 = *(xp + 2);
      x3 = *(xp + 3);

      y0 += h0 * x0;
      y0 += h1 * x3;
      y0 += h2 * x2;
      y0 += h3 * x1;

      h0 = *(hp + 4);
      h1 = *(hp + 5);
      h2 = *(hp + 6);
      h3 = *(hp + 7);
      hp += 4;
    }
    
    /* Need to catch the case where the signal length is close (within
       the blocking factor) to the filter length */

    if (h_ntail == 0) goto done1;
    y0 += h0 * *xp;

    if ((h_ntail == 1) || (xp == x)) goto done1;
    y0 += h1 * *--xp;

    if ((h_ntail == 2) || (xp == x)) goto done1;
    y0 += h2 * *--xp;

  done1:
    *y++ = y0;
  }
}

