/*
** $Header: /u/spert/src/fltvec/tor/RCS/tor_muladd_vffvf_vf.S,v 1.1 1995/06/28 22:14:23 davidj Exp $
**
** Vector floating point saxpy using millicode routines
*/

#include "tor/tordef.h"
#include "m_regdef.h"

#define length a0
#define xPtr a1
#define aVal a2
#define yPtr a3
#define zPtr t0
#define savedRA t1
#define autoInc t2	/* Length of MAXVLEN elements in bytes */
#define done t3		/* done==1 when finished loop */


#ifdef DECL_tor_muladd_vffvf_vf
void tor_muladd_vffvf_vf(size_t len, const float* x, float a,
			  const float* y, float* res);
#endif

/*
** Note - the function linkage stuff on page D-23 of Kane and Heinrich is
** confusing.  However, if you pass an integer argument first, all following
** floating point arguments are put in integer registers.  Hence we do not
** have to play around with mfc1/mtc1 stuff here.
*/

	.globl	tor_muladd_vffvf_vf

	.ent	tor_muladd_vffvf_vf
tor_muladd_vffvf_vf:
	.set	noreorder
        bgtu    length, MAXVLEN, long
        ctvu    length, vlr
	.set	reorder

/* Len <= MAXVLEN case */

	move	savedRA, ra
	lw.v	va0, xPtr
	mov.vs	va1, aVal
	jal	tor_mul_gfgf_gf
	lw.v	va0, yPtr
	mov.vv	va1, vz0
	lw	zPtr, (4*4)(sp)		/* 5th argument is on the stack */
	jal	tor_add_gfgf_gf
	sw.v	vz0, zPtr
	j	savedRA

/* Len > MAXVLEN case */

long:
	li	v0, MAXVLEN
	ctvu	v0, vlr
	li	autoInc, MAXVLEN * 4
	lwai.v	va0, xPtr, autoInc
	mov.vs	va1, aVal
	lw	zPtr, (4*4)(sp)		/* 5th argument is on the stack */
	move	savedRA, ra

loop:
	jal	tor_mul_gfgf_gf
	mov.vv	va0, vz0
	lwai.v	va1, yPtr, autoInc
	jal	tor_add_gfgf_gf
	lwai.v	va0, xPtr, autoInc
	mov.vs	va1, aVal
	subu	length, MAXVLEN
        sltu	done, length, MAXVLEN+1
	swai.v	vz0, zPtr, autoInc
	beqz	done, loop

	ctvu	length, vlr

	jal	tor_mul_gfgf_gf
	mov.vv	va0, vz0
	lw.v	va1, yPtr
	jal	tor_add_gfgf_gf
	sw.v	vz0, zPtr

	j	savedRA

	.end	tor_muladd_vffvf_vf

