/*
 * pfifInit.C
 * 
 * Init file for pfif, tcl interface to Pfile QN interface
 *
 * 1997apr08 dpwe@icsi.berkeley.edu after farrayInit.cc
 * $Header: /u/drspeech/src/guitools/pfif_otcl/RCS/pfifInit.C,v 1.3 1998/08/20 01:49:57 dpwe Exp $
 */

#include <tcl.h>
#include "pfif_cdl.H" // for *_Init command defs

/* Initialization commands */
extern "C" int Pfif_Init(Tcl_Interp *interp)
{   /* Package opening call */
    int rc = TCL_OK;
    Tcl_CmdInfo dummy;

    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Pfif", PFIF_VERSION);

#ifdef SHLIB_NO_STATIC_INIT
    _pfileif_Init(interp);
#endif /* SHLIB_NO_STATIC_INIT */

    /* Ensure that Otcl is re-kicked to recognize the new cmds */
    if(Tcl_GetCommandInfo(interp, "otcl", &dummy) != 0) {
	// otcl command does exist
	rc = Tcl_Eval(interp, "otcl clear");
    }
    return rc;
}

extern "C" int Pfif_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
//    Tcl_SetResult(interp, "Pfif: cannot load under safe interpreter", 
//		  TCL_STATIC);

//    return TCL_ERROR;

    return Pfif_Init(interp);
}
