/*
 * SoundInit.C
 * 
 * Init file for Sound, tcl interface to Pfile QN interface
 *
 * 1997apr08 dpwe@icsi.berkeley.edu after farrayInit.cc
 * $Header: /u/drspeech/src/guitools/sound_otcl/RCS/SoundInit.C,v 1.2 1998/12/10 08:22:47 dpwe Exp $
 */

#include <tcl.h>

/* Ensure compilation even if we forgot to set this */
#ifndef SOUND_VERSION
#define SOUND_VERSION "0.0"
#endif /* !SOUND_VERSION */

/* Initialization commands */
extern "C" int Sound_Init(Tcl_Interp *interp)
{   /* Package opening call */
    int rc = TCL_OK;
    Tcl_CmdInfo dummy;

    // for Tcl7.5+, signal the package mechanism
    Tcl_PkgProvide(interp, "Sound", SOUND_VERSION);

#ifdef SHLIB_NO_STATIC_INIT
    _SOUND_Init(interp);
    _Sound_Init(interp);
#endif /* SHLIB_NO_STATIC_INIT */

    /* Ensure that Otcl is re-kicked to recognize the new cmds */
    if(Tcl_GetCommandInfo(interp, "otcl", &dummy) != 0) {
	// otcl command does exist
	rc = Tcl_Eval(interp, "otcl clear");
    }
    return rc;
}

extern "C" int Sound_SafeInit(Tcl_Interp *interp)
{   /* Package opening call */
//    Tcl_SetResult(interp, "Sound: cannot load under safe interpreter", 
//		  TCL_STATIC);
//    return TCL_ERROR;

    return Sound_Init(interp);
}

#include <Otcl.H>
#include <dpwelib/Sound.H>
#include "SoundTcl.H"

/* function to access sound pointer from Tcl name */
Sound *SoundFromName(char *name) {
    /* Convert a Tcl name into a sound pointer by accessing the Otcl table */
    Sound *sound;
    sound = (Sound*)Otcl::otclPtr->obrefToCpp(name,"Sound");
    return sound;
}

