/*
** $Header: /u/drspeech/src/SPRACHcore/H-i586-linux/intvec/../../intvec/tor/RCS/m_regdef.h,v 1.1 1995/10/10 18:48:10 davidj Exp $
**
** Vector register declarations for millicode routines
*/

#define vtt $vr1
#define vz0 $vr2
#define vz1 $vr3
#define va0 $vr4
#define va1 $vr5
#define va2 $vr6
#define va3 $vr7
#define vt0 $vr8
#define vt1 $vr9
#define vt2 $vr10
#define vt3 $vr11
#define vt4 $vr12
#define vt5 $vr13

/*

Inputs/outputs:
	va0--va3 (preferred vector inputs)
	vz0--vz1 (preferred vector outputs)
	t0--t3 (preferred scalar inputs)
	v0--v1 (preferred scalar outputs)

	Each millicode routine must define its own interface.

Callee-saved registers:
	s0--s8, gp, sp
	a0--a3
	t0--t3, if not used as outputs

	As far as the scalar registers are concerned, the difference from
	the usual convention is that a0--a3 are callee-saved, and t0--t3 are
	also callee-saved if not used as outputs.

Caller-saved registers:
	all others

Default single-precision millicode routine conventions:
    Inputs:
	va0      A operand
	va1      B operand
	t0       pointer to next A to load
	t1       autoincrement or stride for loading next A
	t2       pointer to next B to load, or fixed-point scale for A
	t3       autoincrement or stride for loading next B, or fixed-point
	             scale for B or Z

    Outputs:
	vz0      Z result
	va0      loaded next A
	va1      loaded next B
	v0       saturation flags

    Destroyed:
	vtt
	vv3
	va2--va3
	vt0--vt5
	v0--v1
	t4--t9

Default double-precision millicode routine conventions:
    Inputs:
	va0,va1  A operand
	va2,va3  B operand
	t0       pointer to next A to load
	t1       autoincrement or stride for loading next A
	t2       pointer to next B to load, or fixed-point scale for A
	t3       autoincrement or stride for loading next B, or fixed-point
	             scale for B or Z

    Outputs:
	vz0,vz1  Z result
	va0,va1  loaded next A
	va2,va3  loaded next B
	v0       saturation flags

    Destroyed:
	vtt
	vt0--vt5
	v0--v1
	t4--t9

*/

