#ifndef NO_RCSID
const char* QN_libc_rcsid =
    "$Header: /n/lasagna/db/davidj/spert/src/quicknet/RCS/QN_libc.c,v 1.9 1996/04/27 01:30:49 davidj Exp $";
#endif
/* This file contains some C library functions that may not exist on all
** systems
*/

#include <QN_config.h>
#include <stdio.h>
#include <errno.h>
#include "QN_libc.h"


#ifndef QN_HAVE_FSETPOS

int fseek(FILE* stream, long offset, int);

int
fsetpos(FILE* stream, const fpos_t *pos)
{
    int ec;

    ec = fseek(stream, *pos, 0);
    return(ec);
}

int
fgetpos(FILE* stream, fpos_t *pos)
{
    *pos = ftell(stream);
    return 0;
}

#endif

#ifndef QN_HAVE_STRERROR

extern int sys_nerr;
extern char* sys_errlist[];

char*
strerror(int errnum)
{
    char* unknown = "unknown error";

    if (errnum<sys_nerr)
	return(sys_errlist[errnum]);
    else
	return(unknown);
}

#endif

#ifndef QN_HAVE_STRSTR
#error oh dear, there is no strstr() function on your system or in this file 
#endif

#ifndef QN_HAVE_VPRINTF
#error oh dear, there is no vprintf() function on your system or in this file 
#endif

void
conv_vi8_vi32(size_t len, const intv_int8_t* from, intv_int32_t* to)
{
    size_t i;

    for (i=0; i<len; i++)
	*to++ = *from++;
}

void
conv_vi32_vf(size_t len, const intv_int32_t* from, float* to)
{
    size_t i;

    for (i=0; i<len; i++)
	*to++ = (float) *from++;
}

