. $Header: /n/crab/da/dpwe/projects/berpdemo/simpleberp/RCS/simpleui.man,v 1.2 1997/07/22 00:30:29 dpwe Exp $
.de PN
.ie t \&\f(CB\\$1\f(NR\\$2
.el \fI\\$1\fP\\$2
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.TH SIMPLEUI 1 "$Date: 1997/07/22 00:30:29 $" ICSI "ICSI SPEECH SOFTWARE"
.SH NAME
simpleui \- a simple interactive speech-recognition demonstration.
.SH SYNOPSIS
\fBsimpleui
[fwpmachine=\fImachine\fB]
[decodemachine=\fImachine\fB]
[soundfile.in]
.SH DESCRIPTION
.PN simpleui
is a shell script that links together all the components of 
a simple interactive speech-recognition system using the typical 
components used at ICSI.  Firstly, speech is captured interactively 
with the 
.MS audio_frontend 1 
panel.  It is then converted to online features via 
.MS rasta 1 .
These are passed to the neural-net classifier, implemented by 
.MS qnsfwd 1 ,
which uses the normalization and weight files distributed with 
this script (currently derived from the Berkeley Restaurant Project (BeRP)). 
The posterior probabilities are then decoded into utterances by 
.MS noway 1 , 
which relies on prior, model, dictionary and trigram data files in this 
distribution.  The resulting word hypotheses are sent back to the 
user-interface panel for display.
.P
If \fBfwpmachine=\fImachine\fR is specified, the neural-net classifier 
forward-pass is executed on that machine.  Since this is accomplished by 
a simple "rsh", the forward-pass program must be in the default path 
on that machine.  A similar restriction applies to the use of 
\fBdecodemachine=\fImachine\fR, which specifies the machine where the 
decoder will run.
.P
Specifying an input soundfile will make the program run a single recognition 
on that file rather than using the interactive panel.  The recognized words 
will be printed to the terminal.

.SH FILES
.PN simpleui 
employs the following data files, by convention installed into 
/usr/local/models/simpleui :
.TP 12
simple.norms, simple.wts
Specify the neural network weights and normalization constants.  These 
files must match the network type and geometry specified in the 
qnsfwd command line in the script.
.TP 12
simple.noway.priors, simple.noway.phmodels, 
.TP 12
simple.noway.dict, simple.noway.trigram
Data files for the 
.MS noway 1
decoder which specify the lexicon, grammar and pronunciations for this task. 
(Currently these are questions about locating a restaurant).

.SH ENVIRONMENT
.PN simpleui
relies on the standard \f4$DRSPEECH_PATH\f1 to find the various 
programs it uses.  
.P
The location of the data files should be 'baked-in' by the install 
process; however, this can be overridden by setting the \f4$SIMPLEUI_DATADIR\f1
environment variable.

.SH BUGS
It sets its own path from \f4$DRSPEECH_PATH\f1, but doesn't do this on 
remote machines (i.e. fwpmachine and decodemachine).

.SH AUTHOR
Dan Ellis <dpwe@ICSI.Berkeley.EDU>
